#ifndef ANALOGIN_H
#define ANALOGIN_H

#include "stdio.h"
#include "PinName.h"

class AnalogIn {
public: 

AnalogIn(PinName pin, const char *name = NULL) ;
// Create an AnalogIn, connected to the specified pin
// Variables
// pin    AnalogIn pin to connect to
// name    (optional) A string to identify the object

// read
float read() ;
// Read the input voltage, represented as a float in the range [0.0, 1.0]
//
// Variables
// returns    A floating-point value representing the current input voltage, measured as a percentage

// read_u16
unsigned short read_u16() ;
// Read the input voltage, represented as an unsigned short in the range [0x0, 0xFFFF]

// Variables
// returns    16-bit unsigned short representing the current input voltage, normalised to a 16-bit value

// operator float
operator float() ;
// An operator shorthand for read()
// The float() operator can be used as a shorthand for read() to simplify common code sequences

private:

    PinName p ;
    unsigned short gr_p ;
    const char *objName ;
} ;

#endif