#include "rxbed_wait.h"
#define MblibAssert(name, exp, message, ... ) \
    if(!(exp)) { \
        MblibAlartLED() ;\
        InitUSBCom(10) ;\
        printf("\r[ERROR: %s] ", name) ; printf(message, __VA_ARGS__ ) ; \
        while(1)wait(0.1F) ; \
    }
 
#define MblibAssertPin(name, p, pMin, pMax) \
    MblibAssert(name, (pMin <= p) && (p <= pMax), "p%d is out of the range (p%d - p%d).", p, pMin, pMax) 

#define MblibAssertFloat0_1(name, f) \
    MblibAssert(name, (0.0F <= f) && (f <= 1.0F), "Value %f is out of range (0.0 - 0.1).", (double)f) 

#define MblibAssertFloatPositive(name, f) \
    MblibAssert(name, (0.0F <= f), "Value %f is negative.", (double)f) 

#define MblibAssertIntPositive(name, i) \
    MblibAssert(name, (0 <= i), "Value %d is negative.", i) 

#define MblibAssertInt0_max(name, i, iMax) \
    MblibAssert(name, (0 <= i) && (i<= iMax), "Value %d is out of the range (0 - %d).", i, iMax) 

#define MblibAssertIntmin_max(name, i,iMin, iMax) \
    MblibAssert(name, (iMin <= i) && (i<= iMax), "Value is out of the range.(%d)", i) 


#define MblibSatulation(val, min, max) ((val > min ? val : min)  < max ? val : max)


extern void MblibAlartLED() ;
extern void InitUSBCom(int) ;
