/***********************************************************************************************/
/***     Class: BusIn, BusIn.cpp                                                     ***/
/***********************************************************************************************/
#include <rxduino.h> 
#include "BusIn.h"
#include "rxbed_iodefine.h"

BusIn::BusIn(    
        PinName arg_p0,
        PinName arg_p1,
        PinName arg_p2,        
        PinName arg_p3,
        PinName arg_p4,
        PinName arg_p5,
        PinName arg_p6,
        PinName arg_p7,
        PinName arg_p8,
        PinName arg_p9,
        PinName arg_p10,
        PinName arg_p11,
        PinName arg_p12,        
        PinName arg_p13,
        PinName arg_p14,
        PinName arg_p15,
        const char *name){
    // IOport[pin]: port address * * 8 + bitpos
    
    for(int i = 0; i<16; i++) { readBit[i] = -1 ; } // set as UNDEFINED
    
    p[0]  = arg_p0 ; 
    p[1]  = arg_p1 ;
    p[2]  = arg_p2 ;
    p[3]  = arg_p3 ;
    p[4]  = arg_p4 ;
    p[5]  = arg_p5 ;
    p[6]  = arg_p6 ;
    p[7]  = arg_p7 ;
    p[8]  = arg_p8 ;
    p[9]  = arg_p9 ;
    p[10] = arg_p10 ;
    p[11] = arg_p11 ;
    p[12] = arg_p12 ;
    p[13] = arg_p13 ;
    p[14] = arg_p14 ;
    p[15] = arg_p15 ;
    
    for(int i = 0; (i<16) && (p[i] != NC) ; i++) {
        readBit[i]  = 0x1 << (IOport[p[i]].bitpos) ;
        bitPos[i] = IOport[p[i]].bitpos ;
        ioAddr[i] = (unsigned char *)(IOport[p[i]].addr + RXBED_PORT_PIDR) ;
        *(unsigned char *)(IOport[p[i]].addr + RXBED_PORT_PDR) &= (~readBit[i]) ; // set the bit to Input
//#define DEBUG
#ifdef DEBUG
        printf("p%d: readBit = %d, bitPos = %d, ioAddr = %x\n", i, readBit[i], bitPos[i], ioAddr[i]) ;
#endif
        
    }
    Binname = name ;
} 

int BusIn::read(){
    int val = 0 ;

#ifdef DEBUG
    printf("BusIn::pin = ") ;
#endif
    
    for(int i = 0; (i<16) && (p[i] != NC) ; i++) {
        val |= (*ioAddr[i] & readBit[i]) >> (bitPos[i] - i) ;
#ifdef DEBUG
        printf("p[%d] ", p[i]) ;
#endif

    }

#ifdef DEBUG
    printf("BusIn::read = %x\n", val) ;
#endif
#undef DEBUG

    return val ;
}

BusIn:: operator int() { 
    int val = 0 ;

#ifdef DEBUG
    printf("BusIn::") ;
#endif
    
    for(int i = 0; (i<16) && (p[i] != NC) ; i++) {
        val |= (*ioAddr[i] & readBit[i]) >> (bitPos[i] - i) ;
#ifdef DEBUG
        printf("p[%d]=%d, ", i, p[i]) ;
#endif

    }

#ifdef DEBUG
    printf("\nBusIn::read = %x\n", val) ;
#endif
#undef DEBUG

    return val ;
}  
