/***********************************************************************************************/
/***     Class: BusOut, BusOut.cpp                                                           ***/
/***********************************************************************************************/
#include <rxduino.h>
#include "BusOut.h"
#include "rxbed_iodefine.h"
    
BusOut::BusOut(    
        PinName arg_p0,
        PinName arg_p1,
        PinName arg_p2,        
        PinName arg_p3,
        PinName arg_p4,
        PinName arg_p5,
        PinName arg_p6,
        PinName arg_p7,
        PinName arg_p8,
        PinName arg_p9,
        PinName arg_p10,
        PinName arg_p11,
        PinName arg_p12,        
        PinName arg_p13,
        PinName arg_p14,
        PinName arg_p15,
        const char *name){
    // IOport[pin]: port address * * 8 + bitpos
    
    p[0]  = arg_p0 ; 
    p[1]  = arg_p1 ;
    p[2]  = arg_p2 ;
    p[3]  = arg_p3 ;
    p[4]  = arg_p4 ;
    p[5]  = arg_p5 ;
    p[6]  = arg_p6 ;
    p[7]  = arg_p7 ;
    p[8]  = arg_p8 ;
    p[9]  = arg_p9 ;
    p[10] = arg_p10 ;
    p[11] = arg_p11 ;
    p[12] = arg_p12 ;
    p[13] = arg_p13 ;
    p[14] = arg_p14 ;
    p[15] = arg_p15 ;
    
    for(int i = 0; (i<16) && (p[i] != NC) ; i++) {
        setBit[i]  = 0x1 << (IOport[p[i]].bitpos) ;
        resetBit[i] = ~setBit[i] ;
        ioAddr[i] = (unsigned char *)(IOport[p[i]].addr + RXBED_PORT_PODR) ;
        *(unsigned char *)(IOport[p[i]].addr + RXBED_PORT_PDR) |= setBit[i] ; // set the bit to Output
//#define DEBUG        
#ifdef DEBUG
        printf("p%d: setBit = %d, restBit = %d, ioAddr = %x\n", i, setBit[i], resetBit[i], ioAddr[i]) ;
#endif

    }
    ObjName = name ;
} 

void BusOut::write(int value){
    int i, v ;
#ifdef DEBUG
    printf("BusOut::write = %x\n", value) ;
#endif


#ifdef DEBUG
    printf("BusOut::pin = ") ;
#endif
    
    for(i = 0; (i<16) && (p[i] != NC) ; i++) {
        v = (value >> i) & 0x1 ;     
        #ifdef DEBUG
        printf("p[%d] ", v) ;
#endif
        if(v) { *ioAddr[i] |= setBit[i] ; }
        else  { *ioAddr[i] &= resetBit[i] ; }
    }
    outvalue = value ;
#ifdef DEBUG
    printf("p[%d]=%d, ", i, v) ;
#endif
}

int BusOut::read (){ 
    return(outvalue) ;
} 

void BusOut:: operator= (int value) {
    int v ;
#ifdef DEBUG
    printf("BusOut::write = %x\n", value) ;
#endif


#ifdef DEBUG
    printf("BusOut::pin = ") ;
#endif
    
    for(int i = 0; (i<16) && (p[i] != NC) ; i++) {
        v = (value >> i) & 0x1 ;     
#ifdef DEBUG
        printf("p[%d]=%d, ", i, v) ;
#endif
        if(v) { *ioAddr[i] |= setBit[i] ; }
        else      { *ioAddr[i] &= resetBit[i] ; }
    }
#ifdef DEBUG
        printf("\n") ;
#endif
    outvalue = value ;
    
} 

BusOut:: operator int(){ 
    return(outvalue) ;
} 
#undef DEBUG
