/***********************************************************************************************/
/***     Class: DigitalInOut, DigitalInOut.cpp                                               ***/
/***********************************************************************************************/
#include <rxduino.h>
#include "DigitalInOut.h"
#include "rxbed_iodefine.h"

DigitalInOut::DigitalInOut(PinName pin, const char *name){
        // IOport[pin]: port address * * 8 + bitpos

        // for write
        setBit  = 0x1 << (IOport[pin].bitpos) ; 
        resetBit = ~setBit ;
        outAddr = (unsigned char *)(IOport[pin].addr + RXBED_PORT_PODR) ;
        // for read
        readBit  = 0x1 << (IOport[pin].bitpos) ; 
        bitPos = IOport[pin].bitpos ;
        inAddr = (unsigned char *)(IOport[pin].addr + RXBED_PORT_PIDR) ;
        *(unsigned char *)(IOport[pin].addr + RXBED_PORT_PDR) &= (~readBit) ; // set the bit to Input for now
        p = pin ;
        DOname = name ;
} 

void DigitalInOut::write(int value){
    if(inout == INPUT)
        DigitalInOut::output() ;
        
    outvalue = value ;        
    if(value) { *outAddr |= setBit ; }
    else      { *outAddr &= resetBit ; } 
}

int DigitalInOut::read(){
    if(inout == OUTPUT)
        DigitalInOut::input() ;
    outvalue = (*inAddr & readBit) >> bitPos ;    
    return outvalue ; 
}


void DigitalInOut::output(void){
    *(unsigned char *)(IOport[p].addr + RXBED_PORT_PDR) |= setBit ; // set the bit to Output 
    inout = OUTPUT ;
    outvalue = LOW ;
}

void DigitalInOut::input(void){
    *(unsigned char *)(IOport[p].addr + RXBED_PORT_PDR) &= (~readBit) ; // set the bit to Input
    inout = INPUT ;
}


DigitalInOut& DigitalInOut:: operator= (int value) { 
    if(inout == INPUT)
        DigitalInOut::output() ;
    outvalue = value ; 
    if(value) { *outAddr |= setBit ; }
    else      { *outAddr &= resetBit ; } 
} 
  
DigitalInOut:: operator int(){ 

    if(inout == OUTPUT) {
#ifdef    DEBUG
        printf("Digital I/O, return outvalue\n") ;
#endif
        return outvalue ;
    } else {
#ifdef    DEBUG
        printf("Digital I/O, read port\n") ;
#endif
        outvalue = ((*inAddr & readBit) >> bitPos) ;    
#ifdef    DEBUG
        printf("inAddr=%x, readBit=%x, bitPos=%d, outvalue=%d\n", inAddr, readBit, bitPos, outvalue) ;
#endif
        return outvalue ; 
        //return (*ioAddr & readBit) >> bitPos ; 
    }
} 

