// Timer Table shared with Ticker/Timeout
#define TimerINT_uSec 10

#define TTbl_MAXTIMERS 16

enum TTbl_type { TICKER, TIMEOUT } ;

extern struct TTbl_Timer_t {
    void (*fptr)(void) ;
    int interval ; // uSec
    unsigned long timeout  ; 
    unsigned long now_carry ;
    unsigned long timeout_carry ;
    // For Ticker/Timeout with float value
    void (*fp_fptr)(void) ;
    int fp_InitSec ; // initial value
    int fp_sec ;     // count down value
    int fp_InituSec ;  // initial remainder value
    int fp_uSec ;      // remainder

    TTbl_type type ;   // TICKER/TIMEOUT
    
    } TTbl_Timer[TTbl_MAXTIMERS] ;
    
extern int TTbl_NTimers ;
extern void TTbl_init() ;
extern void TTbl_fpTimer() ;


extern void TTbl_set_f(struct TTbl_Timer_t *p, float t, TTbl_type type) ;
extern void TTbl_set_us(struct TTbl_Timer_t *p, unsigned int t, TTbl_type type) ;
