/***********************************************************************************************/
/***     GR-sakura, GR-ume IO port definition, rxbed_iodefine.cpp                            ***/
/***********************************************************************************************/
#include <rxduino.h>
#include "rxbed_iodefine.h"

#define RXBED_SAKURA
#ifdef  RXBED_SAKURA



/*** brd_grsakura.h 

// ピン番号マクロ
#define PIN_P21      0  //!< @brief PORT2.1 RXD0と共有
#define PIN_P20      1  //!< @brief PORT2.0 TXD0と共有
#define PIN_P22      2  //!< @brief PORT2.2 
#define PIN_P23      3  //!< @brief PORT2.3 
#define PIN_P24      4  //!< @brief PORT2.4 
#define PIN_P25      5  //!< @brief PORT2.5 
#define PIN_P32      6  //!< @brief PORT3.2 TXD6と共有
#define PIN_P33      7  //!< @brief PORT3.3 RXD6と共有
#define PIN_PC2      8  //!< @brief PORTC.2 SPI_CS3と共有
#define PIN_PC3      9  //!< @brief PORTC.3 
#define PIN_PC4      10 //!< @brief PORTC.4 SPI_CS0と共有
#define PIN_PC6      11 //!< @brief PORTC.6 SPI_MOSIと共有
#define PIN_PC7      12 //!< @brief PORTC.7 SPI_MISOと共有
#define PIN_PC5      13 //!< @brief PORTC.5 SPI_CLKと共有
#define PIN_P40      14 //!< @brief PORT4.0 ADCのCH0と共有
#define PIN_P41      15 //!< @brief PORT4.1 ADCのCH1と共有
#define PIN_P42      16 //!< @brief PORT4.2 ADCのCH2と共有
#define PIN_P43      17 //!< @brief PORT4.3 ADCのCH3と共有
#define PIN_P44      18 //!< @brief PORT4.4 ADCのCH4と共有
#define PIN_P45      19 //!< @brief PORT4.5 ADCのCH5と共有
#define PIN_P46      20 //!< @brief PORT4.6 ADCのCH6と共有
#define PIN_P47      21 //!< @brief PORT4.7 ADCのCH7と共有
#define PIN_PC0      22 //!< @brief PORTC.0 SPI_CS1と共有
#define PIN_PC1      23 //!< @brief PORTC.1 SPI_CS2と共有
#define PIN_P50      24 //!< @brief PORT5.0 TXD2と共有
#define PIN_P51      25 //!< @brief PORT5.1 
#define PIN_P52      26 //!< @brief PORT5.2 RXD2と共有
#define PIN_P53      27 //!< @brief PORT5.3 BCLKと共有
#define PIN_P54      28 //!< @brief PORT5.4 
#define PIN_P55      29 //!< @brief PORT5.5 
#define PIN_P12      30 //!< @brief PORT1.2 IRQ2/RXD2と共有
#define PIN_P13      31 //!< @brief PORT1.3 IRQ3
#define PIN_P14      32 //!< @brief PORT1.4 IRQ4/USB_DPUPEと共有
#define PIN_P15      33 //!< @brief PORT1.5 IRQ5/メモリカードの挿入信号(挿入でL)と共有
#define PIN_P16      34 //!< @brief PORT1.6 IRQ6/USB_VBUSと共有
#define PIN_P17      35 //!< @brief PORT1.7 IRQ7
#define PIN_PD0      36 //!< @brief PORTD.0 
#define PIN_PD1      37 //!< @brief PORTD.1 
#define PIN_PD2      38 //!< @brief PORTD.2 
#define PIN_PD3      39 //!< @brief PORTD.3 
#define PIN_PD4      40 //!< @brief PORTD.4 
#define PIN_PD5      41 //!< @brief PORTD.5 
#define PIN_PD6      42 //!< @brief PORTD.6 
#define PIN_PD7      43 //!< @brief PORTD.7 
#define PIN_PE0      44 //!< @brief PORTE.0 
#define PIN_PE1      45 //!< @brief PORTE.1 
#define PIN_PE2      46 //!< @brief PORTE.2 
#define PIN_PE3      47 //!< @brief PORTE.3 
#define PIN_PE4      48 //!< @brief PORTE.4 
#define PIN_PE5      49 //!< @brief PORTE.5 
#define PIN_PE6      50 //!< @brief PORTE.6 
#define PIN_PE7      51 //!< @brief PORTE.7 
#define PIN_P07      52 //!< @brief PORT0.7 
#define PIN_P05      53 //!< @brief PORT0.5 DA1と共有
#define PIN_P35      54 //!< @brief PORT3.5 NMIの別名
#define PIN_NMI      54 //!< @brief PORT3.5の別名
#define PIN_PJ3      55 //!< @brief PORTJ.3 ジャンクなI/Oポート
***/


const struct s_IOport IOport[] = {
        /* p0 */ {(t_IOAddr) &PORT2, 1, PIN_P21}, 
        /* p1 */ {(t_IOAddr) &PORT2, 0, PIN_P20}, 
        /* p2 */ {(t_IOAddr) &PORT2, 2, PIN_P22}, 
        /* p3 */ {(t_IOAddr) &PORT2,  3, PIN_P23}, 
        /* p4 */ {(t_IOAddr) &PORT2,  4, PIN_P24},
        /* p5 */ {(t_IOAddr) &PORT2,  5, PIN_P25}, 
        /* p6 */ {(t_IOAddr) &PORT3,  2, PIN_P32},
        /* p7 */ {(t_IOAddr) &PORT3,  3, PIN_P33}, 
        /* p8 */ {(t_IOAddr) &PORTC,  2, PIN_PC2}, 
        /* p9 */ {(t_IOAddr) &PORTC,  3, PIN_PC3}, 
        /* p10*/ {(t_IOAddr) &PORTC,  4, PIN_PC4},
        /* p11*/ {(t_IOAddr) &PORTC,  6, PIN_PC6}, 
        /* p12*/ {(t_IOAddr) &PORTC,  7, PIN_PC7} , 
        /* p13*/ {(t_IOAddr) &PORTC,  5, PIN_PC5}, 
        /* p14*/ {(t_IOAddr) &PORT4,  0, PIN_P40}, 
        /* p15*/ {(t_IOAddr) &PORT4,  1, PIN_P41}, 
        /* p16*/ {(t_IOAddr) &PORT4,  2, PIN_P42}, 
        /* p17*/ {(t_IOAddr) &PORT4,  3, PIN_P43}, 
        /* p18*/ {(t_IOAddr) &PORT4,  4, PIN_P44}, 
        /* p19*/ {(t_IOAddr) &PORT4,  5, PIN_P45}, 
        
        /* p20*/ {(t_IOAddr) &PORT4,  6, PIN_P46}, 
        /* p21*/ {(t_IOAddr) &PORT4,  7, PIN_P47}, 

        /* p22*/ {(t_IOAddr) &PORTC,  0, PIN_PC0}, 
        /* p23*/ {(t_IOAddr) &PORTC,  1, PIN_PC1},         
        /* p24*/ {(t_IOAddr) &PORT5,  0, PIN_P50}, 
        /* p25*/ {(t_IOAddr) &PORT5,  1, PIN_P51}, 
        /* p26*/ {(t_IOAddr) &PORT5,  2, PIN_P52}, 
        /* p27*/ {(t_IOAddr) &PORT5,  3, PIN_P53},
        /* p28*/ {(t_IOAddr) &PORT5,  4, PIN_P54}, 
        /* p29*/ {(t_IOAddr) &PORT5,  5, PIN_P55},
        
        /* p30*/ {(t_IOAddr) &PORT1,  2, PIN_P12}, 
        /* p31*/ {(t_IOAddr) &PORT1,  3, PIN_P13}, 
        /* p32*/ {(t_IOAddr) &PORT1,  4, PIN_P14}, 
        /* p33*/ {(t_IOAddr) &PORT1,  5, PIN_P15}, 
        /* p34*/ {(t_IOAddr) &PORT1,  6, PIN_P16}, 
        /* p35*/ {(t_IOAddr) &PORT1,  7, PIN_P17}, 
        
        /* p36*/ {(t_IOAddr) &PORTD,  0, PIN_PD0}, 
        /* p37*/ {(t_IOAddr) &PORTD,  1, PIN_PD1}, 
        /* p38*/ {(t_IOAddr) &PORTD,  2, PIN_PD2}, 
        /* p39*/ {(t_IOAddr) &PORTD,  3, PIN_PD3}, 
        /* p40*/ {(t_IOAddr) &PORTD,  4, PIN_PD4}, 
        /* p41*/ {(t_IOAddr) &PORTD,  5, PIN_PD5}, 
        /* p42*/ {(t_IOAddr) &PORTD,  6, PIN_PD6}, 
        /* p43*/ {(t_IOAddr) &PORTD,  7, PIN_PD7},
        
        /* p44*/ {(t_IOAddr) &PORTE,  0, PIN_PE0}, 
        /* p45*/ {(t_IOAddr) &PORTE,  1, PIN_PE1}, 
        /* p46*/ {(t_IOAddr) &PORTE,  2, PIN_PE2}, 
        /* p47*/ {(t_IOAddr) &PORTE,  3, PIN_PE3}, 
        /* p48*/ {(t_IOAddr) &PORTE,  4, PIN_PE4}, 
        /* p49*/ {(t_IOAddr) &PORTE,  5, PIN_PE5}, 
        /* p50*/ {(t_IOAddr) &PORTE,  6, PIN_PE6}, 
        /* p51*/ {(t_IOAddr) &PORTE,  7, PIN_PE7},
        
        /* p52*/ {(t_IOAddr) &PORT0,  7, PIN_P07},         
        /* p53*/ {(t_IOAddr) &PORT0,  5, PIN_P05}, 
        
        /* p54*/ {(t_IOAddr) &PORT3,  5, PIN_P35}, 
        /* p55*/ {(t_IOAddr) &PORTJ,  3, PIN_PJ3}, 
        
        /*LED1*/ {(t_IOAddr) &PORTA,  0, PIN_LED0},
        /*LED2*/ {(t_IOAddr) &PORTA,  1, PIN_LED1},
        /*LED3*/ {(t_IOAddr) &PORTA,  2, PIN_LED2},
        /*LED4*/ {(t_IOAddr) &PORTA,  6, PIN_LED3},
        
        /*SW0 */ {(t_IOAddr) &PORTA,  7, PIN_P21}
    } ;
#endif




/*** brd_grume.h

// ピン番号マクロ
#define PIN_PD4      1 // LED1
#define PIN_PD5      2 // LED2
#define PIN_PD6      3 // LED3
#define PIN_PD7      4 // LED4
#define PIN_PC6      5
#define PIN_PC7      6
#define PIN_PC5      7
#define PIN_PC4      8
#define PIN_PC3      9
#define PIN_PC2      10
#define PIN_PE6      11
#define PIN_PE7      12
#define PIN_PE1      13
#define PIN_PE2      14
#define PIN_P45      15
#define PIN_P44      16
#define PIN_P43      17
#define PIN_P42      18
#define PIN_P41      19
#define PIN_P40      20
#define PIN_PE4      21
#define PIN_PE5      22
#define PIN_PE3      23
#define PIN_P24      24
#define PIN_P23      25
#define PIN_P17      26
#define PIN_P21      27
#define PIN_P20      28
#define PIN_PD1      29
#define PIN_PD2      30
***/

//#define RXBED_SAKURA_MINI
#ifdef  RXBED_SAKURA_MINI
const struct s_IOport IOport[] = {
        /* p0 */ {(t_IOAddr) &PORTC, 6, PIN_C6}, 
        /* p1 */ {(t_IOAddr) &PORTD, 4, PIN_D4}, 
        /* p2 */ {(t_IOAddr) &PORTD, 5, PIN_D5}, 
        /* p3 */ {(t_IOAddr) &PORTD, 6, PIN_D6}, 
        /* p4 */ {(t_IOAddr) &PORTD, 7, PIN_D7},
        
        /* p5 */ {(t_IOAddr) &PORTC,  6, PIN_C6}, 
        /* p6 */ {(t_IOAddr) &PORTC,  7, PIN_C7},
        /* p7 */ {(t_IOAddr) &PORTC,  5, PIN_C5}, 
        /* p8 */ {(t_IOAddr) &PORTC,  4, PIN_C4}, 
        /* p9 */ {(t_IOAddr) &PORTC,  3, PIN_C3}, 
        /* p10*/ {(t_IOAddr) &PORTC,  2, PIN_C2},
        
        /* p11*/ {(t_IOAddr) &PORTE,  6, PIN_E6}, 
        /* p12*/ {(t_IOAddr) &PORTE,  7, PIN_E7} , 
        /* p13*/ {(t_IOAddr) &PORTE,  5, PIN_E1}, 
        /* p14*/ {(t_IOAddr) &PORTE,  0, PIN_E2},
        
        /* p15*/ {(t_IOAddr) &PORT4,  5, PIN_45},
        /* p16*/ {(t_IOAddr) &PORT4,  4, PIN_44},
        /* p17*/ {(t_IOAddr) &PORT4,  3, PIN_43},
        /* p18*/ {(t_IOAddr) &PORT4,  2, PIN_42},
        /* p19*/ {(t_IOAddr) &PORT4,  1, PIN_41},
        /* p20*/ {(t_IOAddr) &PORT4,  0, PIN_40},
        
        /* p21*/ {(t_IOAddr) &PORTE,  4, PIN_E4},
        /* p22*/ {(t_IOAddr) &PORTE,  5, PIN_E5},
        /* p23*/ {(t_IOAddr) &PORTE,  3, PIN_E3},
        /* p24*/ {(t_IOAddr) &PORT2,  4, PIN_24},
        /* p25*/ {(t_IOAddr) &PORT2,  3, PIN_23},
        /* p26*/ {(t_IOAddr) &PORT1,  7, PIN_17},
        /* p27*/ {(t_IOAddr) &PORT2,  1, PIN_21},
        /* p28*/ {(t_IOAddr) &PORT2,  0, PIN_20},
        /* p29*/ {(t_IOAddr) &PORTD,  1, PIN_D1},
        /* p30*/ {(t_IOAddr) &PORTD,  2, PIN_D2},

        /* LED1 */ {(t_IOAddr) &PORTD, 4, PIN_D4}, 
        /* LED2 */ {(t_IOAddr) &PORTD, 5, PIN_D5}, 
        /* LED3 */ {(t_IOAddr) &PORTD, 6, PIN_D6}, 
        /* LED4 */ {(t_IOAddr) &PORTD, 7, PIN_D7},
        
        /* SW0  */ {(t_IOAddr) &PORTC, 6, PIN_C6}, 

    } ;

  




#endif
