/***********************************************************************************************/
/***     Class: Wait, rxbed_wait.cpp                                                         ***/
/***********************************************************************************************/
#include <rxduino.h>
// DON'T INCLUDE mbed.h #include <mbed.h>
// mbed.h replace delay to wait
#include "rxbed_wait.h"
#include "SysTick.h"
 
// #define DEBUG
#ifdef  DEBUG
#include <DigitalOut.h>
static DigitalOut tp(p7) ;
void test_tick() {
    int v ;
    printf("tp = %d\n", v = tp ) ;
    tp = !tp ;         
}
#endif

extern void Ticker_tick() ;
#define TICKuSec (TICKER_uSec - 1)
void wait(float s) {

#ifdef DEBUG
    printf("wait(%f)\n", s) ;
#endif

    if(s > (float) 0.1) {
        int msec = s * 1000 ;
        wait_ms(msec) ;
    } else { /* wait_us(us) */
       unsigned long begin_wait = micros() ;
       int us = s * 1000000.0 ;
       int w_us = us ;
       int r = us % TICKuSec ; 

// printf("wait(%f), us=%d\n", s, us) ;
       for( ; us > 0 ; us -= TICKuSec) {
           delayMicroseconds((unsigned long) TICKuSec) ;
//         Ticker_tick() ;
#ifdef DEBUG
           test_tick() ;
#endif
            if((micros() - begin_wait) > w_us) // check if the tick is too slow
                return ;
        } 
        if(r) {
            // printf("wait(%f), r=%d,\n", s, r) ;
            delayMicroseconds((unsigned long) r) ;
//          Ticker_tick() ;
#ifdef DEBUG
           test_tick() ;
#endif
        }
    }
}

void wait_ms(int ms) {

unsigned int begin_wait = micros() ;

#ifdef DEBUG
    printf("wait_ms: %d\n", ms) ;
#endif

    for(int j = ms ; j > 0 ; j --) {
        for(int i = 1000/TICKuSec ; i>0; i -- ) {
            delayMicroseconds((unsigned long) TICKuSec) ;
//          Ticker_tick() ;
#ifdef DEBUG
           test_tick() ;
#endif
            if((micros() - begin_wait) > ms*1000) // check if the tick is too slow
                return ;
        }
    }
}

void wait_us(int arg_us) {
   unsigned int begin_wait = micros() ;
   int us = arg_us ;
   int r = us % TICKuSec ; 
   
#ifdef DEBUG
   printf("wait_us: %d\n", arg_us) ;
#endif
   for( ; us > 0; us -= TICKuSec) {
        delayMicroseconds((unsigned long) TICKuSec) ;
//      Ticker_tick() ;
#ifdef DEBUG
           test_tick() ;
#endif
            if((micros() - begin_wait) > arg_us) // check if the tick is too slow
                return ;
    } 
    
    if(r) {
        delayMicroseconds((unsigned long) r) ;
//      Ticker_tick() ;
#ifdef DEBUG
           test_tick() ;
#endif
    }
}
